local m_tblTestScriptState = {
	activeCullingRadius = 420.0,
}

local testVehicleModel = "virtue"

local function createTestVehicle()
	RequestModel(testVehicleModel)
	while not HasModelLoaded(testVehicleModel) do Wait(0) end

	local spawnPosition = GetEntityCoords(PlayerPedId(), false)

	local vehicle = CreateVehicle(testVehicleModel, spawnPosition.x, spawnPosition.y, spawnPosition.z, 0.0, true, true)
	SetEntityInvincible(vehicle, true)

	m_tblTestScriptState.vehicle = vehicle
	m_tblTestScriptState.vehicleNetId = VehToNet(m_tblTestScriptState.vehicle)

	TriggerServerEvent("setTestVehicleNetId", m_tblTestScriptState.vehicleNetId)
end

function DrawCenterText(msg, time, ...)
	ClearPrints()

	AddTextEntry("OSD_OBJTXT", msg)
	BeginTextCommandPrint("OSD_OBJTXT")
	EndTextCommandPrint(time or 0, true)
end

RegisterCommand("create_test_vehicle", function()
	createTestVehicle()
end, false)

CreateThread(function()
	while true do
		Wait(0)

		if IsControlJustPressed(0, 45) and m_tblTestScriptState.vehicleNetId then -- R
			if not NetworkDoesEntityExistWithNetworkId(m_tblTestScriptState.vehicleNetId) then print('no entity with network id', m_tblTestScriptState.vehicleNetId) end
			-- Request vehicle ownership
			NetworkRequestControlOfNetworkId(m_tblTestScriptState.vehicleNetId)
		end

		if IsControlJustPressed(0, 166) then -- F5
			-- Set small radius
			m_tblTestScriptState.activeCullingRadius = 16.0
			TriggerServerEvent("setPlayerCullingRadius", m_tblTestScriptState.activeCullingRadius)
		end

		if IsControlJustPressed(0, 167) then -- F6
			-- Set big radius
			m_tblTestScriptState.activeCullingRadius = 420.0
			TriggerServerEvent("setPlayerCullingRadius", m_tblTestScriptState.activeCullingRadius)
		end

		DrawCenterText("Culling radius: " .. m_tblTestScriptState.activeCullingRadius)
	end
end)

RegisterNetEvent("setTestVehicleNetId_client")
AddEventHandler("setTestVehicleNetId_client", function(netId)
	m_tblTestScriptState.vehicleNetId = netId
end)

AddEventHandler("onResourceStop", function(resourceName)
	if resourceName ~= GetCurrentResourceName() then return end

	if m_tblTestScriptState.vehicle then
		DeleteEntity(m_tblTestScriptState.vehicle)
	end
end)